if WScript.Arguments.Count <> 5 then
	MsgBox "Usage:" & vbCrLf & vbCrLf & "prepare_atr.vbs <credits> <question set 1> <question set 2> <question set 3> <question set 4>", 32, "Wrong arguments"
	WScript.Quit
end if

set objFSO=CreateObject("Scripting.FileSystemObject")
char_array=Array(0,96,123,125,126,127,128,129,130,131,132,133,134,135,136,137,138,139,140,141,142,143,144,145,146,147,148,149,150,151,152,153,154,155,156,157,158,159,160,161,162,163,164,165,190,191,192,193,194,195,196,197,182,183,184,185,186,187,188,189)
char_width=Array(2,2,5,7,6,6,7,2,3,3,7,6,2,4,2,4,5,3,5,5,6,5,5,5,5,5,2,2,4,4,4,6,7,6,6,6,6,6,6,6,6,2,6,6,6,7,6,6,6,6,6,6,6,6,6,7,6,6,6,3,4,3,5,4,6,5,5,4,5,5,5,5,5,2,4,5,2,7,5,5,5,5,5,5,5,5,5,7,5,5,5,7,2,7,4,5,5,5,5,5,5,5,3,5,5,5,5,5,5,5,5,5,6,6,6,6,6,3,6,6,6,6,6,6,6,6,6,5,5,5,6,6,6,6,3,4,5,5,6,6,6,6,7,6,6,6,7,5,7,7,5,5,5,4,5,5,5,5,6,6,6,6,6,6,6,6,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8)
text_max=Array(288,121,121,121,121)

sub parseText(text,maxlen,filename)
	width=0
	twolines=0
	lastspaces=Array(999,999)
	for i=1 to len(text)
		if mid(text,i,1)=" " then lastspaces(twolines)=i
		width=width+char_width(asc(mid(text,i,1))-32)+1
		if width>maxlen then
			if lastspaces(0)=999 then
				msgbox "The first line can not be splitted!" & vbCrLf & vbCrLf & mid(text,1,i),16,filename
				exit for
			elseif twolines=0 then
				i=lastspaces(0)+1
				width=0
				twolines=1
			elseif lastspaces(1)=999 then
				msgbox "The second line can not be splitted!" & vbCrLf & vbCrLf & mid(text,1,lastspaces(0)-1) & vbCrLf & vbCrLf & mid(text,lastspaces(0)+1),16,filename
				exit for
			else
				msgbox "Text too long!" & vbCrLf & vbCrLf & mid(text,1,lastspaces(0)-1) & vbCrLf & mid(text,lastspaces(0)+1,lastspaces(1)-lastspaces(0)-1) & vbCrLf & vbCrLf & mid(text,lastspaces(1)+1),48,filename
				exit for
			end if
		end if
	next
end sub

sub convert(filename, output)
	set inFile = objFSO.OpenTextFile(filename, 1)
	set outFile = objFSO.CreateTextFile("atr\" & output & ".txt", 1)

	questions=0
	sectors=""
	offsets=Chr(0)
	vystup=""

	do until inFile.AtEndOfStream
		for j=1 to 5
			line_tmp=""
			line=inFile.ReadLine
			for i=1 to len(line)
				temp=InStr("{؊ݎܥʣь񜟿", mid(line,i,1))
				if temp>0 then
					line_tmp=line_tmp & Chr(char_array(temp))
				else
					line_tmp=line_tmp & mid(line,i,1)
				end if
			next
			parseText line_tmp,text_max(j-1),filename
			vystup=vystup & line_tmp & Chr(0)
		next
		if not inFile.AtEndOfStream then 
			offsets=offsets & Chr(Len(vystup) mod 128)
			sectors=sectors & Chr(Len(vystup)\128) 
		end if
		questions=questions+1
	loop
	inFile.Close
	
	do until (len(vystup) mod 128)=0
		vystup=vystup & Chr(0)
	loop	
	outFile.Write vystup
	outFile.Close

	offsets=offsets & Chr(Len(vystup) mod 128)
	sectors=sectors & Chr(Len(vystup)\128) 
	do until Len(sectors)=253
		sectors=sectors & Chr(0)
	loop
	do until Len(offsets)=256
		offsets=offsets & Chr(0)
	loop

	set outFile = objFSO.CreateTextFile("atr\" & output & ".dat", 1)
	outFile.Write Chr(questions) & Chr(len(vystup)/128) & Chr(0)
	outFile.Write sectors
	outFile.Write offsets
	outFile.Close
end sub

sub credits(filename, output)
	set inFile = objFSO.OpenTextFile(filename, 1)

	vystup=""

	for j=1 to 8
		line_tmp=""
		line=inFile.ReadLine
		for i=1 to len(line)
			temp=InStr("{؊ݎܥʣь񜟿", mid(line,i,1))
			if temp>0 then
				line_tmp=line_tmp & Chr(char_array(temp))
			else
				line_tmp=line_tmp & mid(line,i,1)
			end if
		next
		vystup=vystup & line_tmp & Chr(0)
	next
	do until Len(vystup)=384
		vystup=vystup & Chr(0)
	loop

	set outFile = objFSO.CreateTextFile("atr\" & output & ".txt", 1)
	outFile.Write vystup
	outFile.Close
end sub

credits WScript.Arguments(0), "credits"
convert WScript.Arguments(1), "q1"
convert WScript.Arguments(2), "q2"
convert WScript.Arguments(3), "q3"
convert WScript.Arguments(4), "q4"
